%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PHY306, Assignment 4, Numerics question template.  IISER Bhopal  2020
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Assignment4

Nobjects = 3;
Ndimensions = 2;

% 1 =  sun
% 2 = earth
% 3 = mars

mass = [1.9891e30   5.97237e24  6.4171e23]; %in kg
G = 6.673e-11;  						    %gravitational constant

%orbital parameters
XXX

% for how long to simulate
tfin_years = 3.0;
year_in_seconds =31556952; 
tfin = tfin_years*year_in_seconds; 	      % final simulation time, in seconds
Nsamples = 200;  					          % number of timesamples
tsamples = linspace(0,tfin,Nsamples);

%define initial conditions in 2D for each object, using cartesian coordinates
x0sun = 0.0; %neglect sun motion for initial conditions (but it is included in simulation)
y0sun = 0.0;
vx0sun = 0.0;
vy0sun = 0.0;

% start all planets at perihelion, for simplicity
x0earth = XXX;
y0earth = XXX;
vx0earth = XXX;;
vy0earth = XXX;

x0mars = XXX;
y0mars = XXX;
vx0mars = XXX;
vy0mars = XXX;

x0 = [x0sun
	  y0sun
	  x0earth
	  y0earth
	  x0mars
	  y0mars];
	  
v0 = [vx0sun
      vy0sun
	  vx0earth
	  vy0earth
	  vx0mars
	  vy0mars];

inicond = [x0; v0];
positions = 1:(Nobjects*Ndimensions);
velos = (Nobjects*Ndimensions + 1):(2*Nobjects*Ndimensions);

% standard matlab differential equation solver:
options = odeset('RelTol',1e-8,'AbsTol',1e-6,'Stats','off','InitialStep',tfin*1e-5);
[tout,xv_out] = ode45(@(t,xv)Newtons_equation(t,xv),tsamples,inicond,options);

save(['assignment4_output.mat'])
display(['Wrote assignment4_output.mat'])

%%%%%%%%%%%%%%%%%%%%%%%%
% internal functions
%%%%%%%%%%%%%%%%%%%%%%%%

function dxv_dt = Newtons_equation(t,xv_in)

acctot=zeros(6,1);
for nn=1:3,    % sum up total acceleration on object nn
  for mm=1:3,  % due to all other objections
     if(nn~=mm) % object must be different
       distvec = xv_in([2*nn-1 2*nn]) - xv_in([2*mm-1 2*mm]);
       dist = sqrt(sum(distvec.*distvec));
       acctot([2*nn-1 2*nn]) = acctot([2*nn-1 2*nn]) - mass(mm)*G*distvec/dist^3;  
     end
  end
end  

dxv_dt = [xv_in(velos) 
          acctot];

end % funct

end % main function