lengthscale = 1e6*1000;
r_mars = sqrt(xv_out(:,5).*xv_out(:,5) + xv_out(:,6).*xv_out(:,6));

Npts = 128;
rgrid = linspace(0.8*min(r_mars),1.2*max(r_mars),Npts);

subplot(1,2,1)
plot(tsamples/year_in_seconds,r_mars/lengthscale,'k')
xlabel(['t [y]'])
ylabel(['r [10^6 km]'])

subplot(1,2,2)

Vgrav=-mass(1)*mass(3)*G*ones(size(rgrid))./rgrid;
Vcent = 0.0;
Emars = 0.0;
Veff = Vcent + Vgrav;

plot(rgrid/lengthscale,Veff,'k')
hold on
plot(rgrid/lengthscale,Emars*ones(size(rgrid)),'r')
hold off
xlabel(['r [10^6 km]'])
ylabel(['V,E [J]'])



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lw=2;
fs=20;

lineobj = findobj('type', 'Line');
set(lineobj,'LineWidth', lw);

patchobj = findobj('type', 'Patch');
set(patchobj,'LineWidth', lw);

textobj = findobj('type', 'axes');
set(textobj,'LineWidth', lw);
set(textobj, 'fontsize', fs);
set(textobj, 'FontName', 'Times');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  